﻿<#

Stops all running vApps and subsequently removes them in an organization.
Reports any Unresolved vApps (Pending or In Maintenance Mode)

#>

# Connects to host (fill in spots)
Connect-CIserver -Server "" -User "" -Password ""

# Get running vApps from $desiredOrg
$desiredOrg = ""

$vApps = Get-CIVapp | where-object {$_.Org.Name -like $desiredOrg}

$vApps | ForEach-Object `
-begin {$counter = 0} `
-process {$counter += 1}

# Stop running vApps (Redirect to supress output.)
Write-Output "`nStopping PoweredOn vApps."
$vApps | where-object {$_.Status -eq "PoweredOn"} | Stop-CIVApp -confirm:$false > $null

# Remove all vApps, except for "Pending" vApps or those in "Maintenance Mode"
Write-Output "`nAttemping to delete $counter vApps."
$vApps | where-object {$_.Status -ne "Unresolved"} | Remove-CIVApp -confirm:$false > $null

# Refetch vApps
$vAppsPost = Get-CIVapp | where-object {$_.Org.Name -like $desiredOrg}

# Check for Unresolved vApps and print error's if any
$vAppsPost | where-object {$_.Status -eq "Unresolved"} | ForEach-Object `
-begin {$unresolved = 0} `
-process {$unresolved += 1}

if ($unresolved -ne 0)
{
    Write-Output "`n$unresolved vApps had issues being removed (Pending or In Maintenance Mode)."
}
else
{
    Write-Output "`nSuccess."
}

# $vAppsPost | Where-Object {$_.Status -eq "Unresolved"} # Debug

Write-Output "`nDone. Disconnecting from Host."

Disconnect-CIServer -Confirm:$false